import logging.handlers
import sys
from typing import TextIO

from .base import dump_api_message


class LoggerAPIHandler(logging.Handler):
    def __init__(self, output: TextIO = sys.stdout):
        super().__init__()
        self.output = output

    def emit(self, record: logging.LogRecord):
        dump_api_message(
            "log", {"level": record.levelname, "message": record.getMessage()}
        )
